(*                                                                          *)
(* (c) 2004, Anastasia Gornostaeva. <ermine@ermine.pp.ru>                   *)
(*                                                                          *)

let hex_to_digit i =
   match i with
      | x when '0' <= x && x <= '9'  -> 
	   (Char.code x) - (Char.code '0')
      | 'A' | 'a' -> 10
      | 'B' | 'b' -> 11
      | 'C' | 'c' -> 12
      | 'D' | 'd' -> 13
      | 'E' | 'e' -> 14
      | 'F' | 'f' -> 15
      | _ -> failwith "Unexpected letter"

let hex_to_int hex =
   let len = String.length hex in
   let rec cycle acc i =
      if i = len then acc
      else cycle (acc * 16 + (hex_to_digit hex.[i])) (i+1)
   in
      cycle 0 0

